Index: main.c
===================================================================
--- main.c	(revision 198625)
+++ main.c	(working copy)
@@ -1,4 +1,4 @@
-/*	$OpenBSD: main.c,v 1.53 2002/04/26 16:15:16 espie Exp $	*/
+/*	$OpenBSD: main.c,v 1.77 2009/10/14 17:19:47 sthen Exp $	*/
 /*	$NetBSD: main.c,v 1.12 1997/02/08 23:54:49 cgd Exp $	*/
 
 /*-
@@ -16,11 +16,7 @@
  * 2. Redistributions in binary form must reproduce the above copyright
  *    notice, this list of conditions and the following disclaimer in the
  *    documentation and/or other materials provided with the distribution.
- * 3. All advertising materials mentioning features or use of this software
- *    must display the following acknowledgement:
- *	This product includes software developed by the University of
- *	California, Berkeley and its contributors.
- * 4. Neither the name of the University nor the names of its contributors
+ * 3. Neither the name of the University nor the names of its contributors
  *    may be used to endorse or promote products derived from this software
  *    without specific prior written permission.
  *
@@ -37,43 +33,24 @@
  * SUCH DAMAGE.
  */
 
-#ifndef lint
-static char copyright[] =
-"@(#) Copyright (c) 1989, 1993\n\
-	The Regents of the University of California.  All rights reserved.\n";
-#endif /* not lint */
-
-#ifndef lint
-#if 0
-static char sccsid[] = "@(#)main.c	8.1 (Berkeley) 6/6/93";
-#else
-#if 0
-static char rcsid[] = "$OpenBSD: main.c,v 1.53 2002/04/26 16:15:16 espie Exp $";
-#endif
-#endif
-#endif /* not lint */
-
-#include <sys/cdefs.h>
-__FBSDID("$FreeBSD$");
-
 /*
  * main.c
  * Facility: m4 macro processor
  * by: oz
  */
 
-#include <sys/types.h>
 #include <assert.h>
 #include <signal.h>
+#include <err.h>
 #include <errno.h>
 #include <unistd.h>
 #include <stdio.h>
 #include <ctype.h>
 #include <string.h>
 #include <stddef.h>
+#include <stdint.h>
 #include <stdlib.h>
-#include <err.h>
-#include <locale.h>
+#include <ohash.h>
 #include "mdef.h"
 #include "stdd.h"
 #include "extern.h"
@@ -86,21 +63,27 @@
 int sp; 			/* current m4  stack pointer   */
 int fp; 			/* m4 call frame pointer       */
 struct input_file infile[MAXINP];/* input file stack (0=stdin)  */
-char *inname[MAXINP];		/* names of these input files */
-int inlineno[MAXINP];		/* current number in each input file */
 FILE **outfile;			/* diversion array(0=bitbucket)*/
 int maxout;
 FILE *active;			/* active output file pointer  */
 int ilevel = 0; 		/* input file stack pointer    */
 int oindex = 0; 		/* diversion index..	       */
-char null[] = "";		/* as it says.. just a null..  */
-const char *m4wraps = "";       /* m4wrap string default..     */
+char *null = "";                /* as it says.. just a null..  */
+char **m4wraps = NULL;		/* m4wraps array.     	       */
+int maxwraps = 0;		/* size of m4wraps array       */
+int wrapindex = 0;		/* current offset in m4wraps   */
 char lquote[MAXCCHARS+1] = {LQUOTE};	/* left quote character  (`)   */
 char rquote[MAXCCHARS+1] = {RQUOTE};	/* right quote character (')   */
 char scommt[MAXCCHARS+1] = {SCOMMT};	/* start character for comment */
 char ecommt[MAXCCHARS+1] = {ECOMMT};	/* end character for comment   */
-int synccpp;			/* Line synchronisation for C preprocessor */
+int  synch_lines = 0;		/* line synchronisation for C preprocessor */
+int  prefix_builtins = 0;	/* -P option to prefix builtin keywords */
 
+struct keyblk {
+        char    *knam;          /* keyword name */
+        int     ktyp;           /* keyword type */
+};
+
 struct keyblk keywrds[] = {	/* m4 keywords to be installed */
 	{ "include",      INCLTYPE },
 	{ "sinclude",     SINCTYPE },
@@ -148,7 +131,7 @@
 	{ "traceon",	  TRACEONTYPE | NOARGS },
 	{ "traceoff",	  TRACEOFFTYPE | NOARGS },
 
-#if defined(unix) || defined(__unix__)
+#if defined(unix) || defined(__unix__) 
 	{ "unix",         SELFTYPE | NOARGS },
 #else
 #ifdef vms
@@ -159,6 +142,9 @@
 
 #define MAXKEYS	(sizeof(keywrds)/sizeof(struct keyblk))
 
+extern int optind;
+extern char *optarg;
+
 #define MAXRECORD 50
 static struct position {
 	char *name;
@@ -172,43 +158,41 @@
 static void initkwds(void);
 static ndptr inspect(int, char *);
 static int do_look_ahead(int, const char *);
+static void reallyoutputstr(const char *);
+static void reallyputchar(int);
 
 static void enlarge_stack(void);
 
+int main(int, char *[]);
+
 int
 main(int argc, char *argv[])
 {
 	int c;
 	int n;
-	int rval;
 	char *p;
 
-	setlocale(LC_ALL, "");
-
-	traceout = stderr;
-
 	if (signal(SIGINT, SIG_IGN) != SIG_IGN)
 		signal(SIGINT, onintr);
 
-	initkwds();
+	init_macros();
 	initspaces();
 	STACKMAX = INITSTACKMAX;
 
-	mstack = (stae *)xalloc(sizeof(stae) * STACKMAX);
-	sstack = (char *)xalloc(STACKMAX);
+	mstack = (stae *)xalloc(sizeof(stae) * STACKMAX, NULL);
+	sstack = (char *)xalloc(STACKMAX, NULL);
 
 	maxout = 0;
 	outfile = NULL;
 	resizedivs(MAXOUT);
 
-	while ((c = getopt(argc, argv, "gst:d:D:U:o:I:")) != -1)
+	while ((c = getopt(argc, argv, "gst:d:D:U:o:I:P")) != -1)
 		switch(c) {
+
 		case 'D':               /* define something..*/
 			for (p = optarg; *p; p++)
 				if (*p == '=')
 					break;
-			if (p == optarg)
-				errx(1, "null variable cannot be defined");
 			if (*p)
 				*p++ = EOS;
 			dodefine(optarg, p);
@@ -216,8 +200,11 @@
 		case 'I':
 			addtoincludepath(optarg);
 			break;
+		case 'P':
+			prefix_builtins = 1;
+			break;
 		case 'U':               /* undefine...       */
-			remhash(optarg, TOP);
+			macro_popdef(optarg);
 			break;
 		case 'g':
 			mimic_gnu = 1;
@@ -226,7 +213,7 @@
 			set_trace_flags(optarg);
 			break;
 		case 's':
-			synccpp = 1;
+			synch_lines = 1;
 			break;
 		case 't':
 			mark_traced(optarg, 1);
@@ -235,14 +222,16 @@
 			trace_file(optarg);
                         break;
 		case '?':
-		default:
 			usage();
 		}
 
         argc -= optind;
         argv += optind;
 
-	rval = 0;
+	initkwds();
+	if (mimic_gnu)
+		setup_builtin("format", FORMATTYPE);
+
 	active = stdout;		/* default active output     */
 	bbase[0] = bufbase;
         if (!argc) {
@@ -250,36 +239,38 @@
 		fp = 0; 		/* frame pointer initialized */
 		set_input(infile+0, stdin, "stdin");
 					/* default input (naturally) */
-		if ((inname[0] = strdup("-")) == NULL)
-			err(1, NULL);
-		inlineno[0] = 1;
-		emitline();
 		macro();
 	} else
 		for (; argc--; ++argv) {
 			p = *argv;
 			if (p[0] == '-' && p[1] == EOS)
 				set_input(infile, stdin, "stdin");
-			else if (fopen_trypath(infile, p) == NULL) {
-				warn("%s", p);
-				rval = 1;
-				continue;
-			}
+			else if (fopen_trypath(infile, p) == NULL)
+				err(1, "%s", p);
 			sp = -1;
-			fp = 0;
-			if ((inname[0] = strdup(p)) == NULL)
-				err(1, NULL);
-			inlineno[0] = 1;
-			emitline();
+			fp = 0; 
 			macro();
 		    	release_input(infile);
 		}
 
-	if (*m4wraps) { 		/* anything for rundown ??   */
+	if (wrapindex) {
+		int i;
+
 		ilevel = 0;		/* in case m4wrap includes.. */
 		bufbase = bp = buf;	/* use the entire buffer   */
-		pbstr(m4wraps); 	/* user-defined wrapup act   */
-		macro();		/* last will and testament   */
+		if (mimic_gnu) {
+			while (wrapindex != 0) {
+				for (i = 0; i < wrapindex; i++)
+					pbstr(m4wraps[i]);
+				wrapindex =0;
+				macro();
+			}
+		} else {
+			for (i = 0; i < wrapindex; i++) {
+				pbstr(m4wraps[i]);
+				macro();
+		    	}
+		}
 	}
 
 	if (active != stdout)
@@ -292,7 +283,7 @@
 		(void) fclose(outfile[0]);
 	}
 
-	exit(rval);
+	return 0;
 }
 
 /*
@@ -312,9 +303,9 @@
 	for (i = 1; *++token; i++) {
 		t = gpbc();
 		if (t == EOF || (unsigned char)t != (unsigned char)*token) {
-			putback(t);
+			pushback(t);
 			while (--i)
-				putback(*--token);
+				pushback(*--token);
 			return 0;
 		}
 	}
@@ -338,61 +329,8 @@
 
 	cycle {
 		t = gpbc();
-		if (t == '_' || isalpha(t)) {
-			p = inspect(t, token);
-			if (p != nil)
-				putback(l = gpbc());
-			if (p == nil || (l != LPAREN &&
-			    (p->type & NEEDARGS) != 0))
-				outputstr(token);
-			else {
-		/*
-		 * real thing.. First build a call frame:
-		 */
-				pushf(fp);	/* previous call frm */
-				pushf(p->type); /* type of the call  */
-				pushf(0);	/* parenthesis level */
-				fp = sp;	/* new frame pointer */
-		/*
-		 * now push the string arguments:
-		 */
-				pushs1(p->defn);	/* defn string */
-				pushs1(p->name);	/* macro name  */
-				pushs(ep);	      	/* start next..*/
 
-				if (l != LPAREN && PARLEV == 0)  {
-				    /* no bracks  */
-					chrsave(EOS);
-
-					if ((uintptr_t)sp == STACKMAX)
-						errx(1, "internal stack overflow");
-					eval((const char **) mstack+fp+1, 2,
-					    CALTYP);
-
-					ep = PREVEP;	/* flush strspace */
-					sp = PREVSP;	/* previous sp..  */
-					fp = PREVFP;	/* rewind stack...*/
-				}
-			}
-		} else if (t == EOF) {
-			if (sp > -1) {
-				warnx( "unexpected end of input, unclosed parenthesis:");
-				dump_stack(paren, PARLEV);
-				exit(1);
-			}
-			if (ilevel <= 0)
-				break;			/* all done thanks.. */
-			release_input(infile+ilevel--);
-			free(inname[ilevel+1]);
-			bufbase = bbase[ilevel];
-			emitline();
-			continue;
-		}
-	/*
-	 * non-alpha token possibly seen..
-	 * [the order of else if .. stmts is important.]
-	 */
-		else if (LOOK_AHEAD(t,lquote)) {	/* strip quotes */
+		if (LOOK_AHEAD(t,lquote)) {	/* strip quotes */
 			nlpar = 0;
 			record(quotes, nlpar++);
 			/*
@@ -418,32 +356,77 @@
 				} else {
 					if (nlpar > 0) {
 						if (sp < 0)
-							putc(l, active);
+							reallyputchar(l);
 						else
 							CHRSAVE(l);
 					}
 				}
 			}
 			while (nlpar != 0);
-		}
+		} else if (sp < 0 && LOOK_AHEAD(t, scommt)) {
+			reallyoutputstr(scommt);
 
-		else if (sp < 0 && LOOK_AHEAD(t, scommt)) {
-			fputs(scommt, active);
-
 			for(;;) {
 				t = gpbc();
 				if (LOOK_AHEAD(t, ecommt)) {
-					fputs(ecommt, active);
+					reallyoutputstr(ecommt);
 					break;
 				}
 				if (t == EOF)
 					break;
-				putc(t, active);
+				reallyputchar(t);
 			}
-		}
+		} else if (t == '_' || isalpha(t)) {
+			p = inspect(t, token);
+			if (p != NULL)
+				pushback(l = gpbc());
+			if (p == NULL || (l != LPAREN && 
+			    (macro_getdef(p)->type & NEEDARGS) != 0))
+				outputstr(token);
+			else {
+		/*
+		 * real thing.. First build a call frame:
+		 */
+				pushf(fp);	/* previous call frm */
+				pushf(macro_getdef(p)->type); /* type of the call  */
+				pushf(is_traced(p));
+				pushf(0);	/* parenthesis level */
+				fp = sp;	/* new frame pointer */
+		/*
+		 * now push the string arguments:
+		 */
+				pushs1(macro_getdef(p)->defn);	/* defn string */
+				pushs1((char *)macro_name(p));	/* macro name  */
+				pushs(ep);	      	/* start next..*/
 
-		else if (sp < 0) {		/* not in a macro at all */
-			putc(t, active);	/* output directly..	 */
+				if (l != LPAREN && PARLEV == 0)  {   
+				    /* no bracks  */
+					chrsave(EOS);
+
+					if (sp == STACKMAX)
+						errx(1, "internal stack overflow");
+					eval((const char **) mstack+fp+1, 2, 
+					    CALTYP, TRACESTATUS);
+
+					ep = PREVEP;	/* flush strspace */
+					sp = PREVSP;	/* previous sp..  */
+					fp = PREVFP;	/* rewind stack...*/
+				}
+			}
+		} else if (t == EOF) {
+			if (sp > -1 && ilevel <= 0) {
+				warnx( "unexpected end of input, unclosed parenthesis:");
+				dump_stack(paren, PARLEV);
+				exit(1);
+			}
+			if (ilevel <= 0)
+				break;			/* all done thanks.. */
+			release_input(infile+ilevel--);
+			emit_synchline();
+			bufbase = bbase[ilevel];
+			continue;
+		} else if (sp < 0) {		/* not in a macro at all */
+			reallyputchar(t);	/* output directly..	 */
 		}
 
 		else switch(t) {
@@ -451,9 +434,10 @@
 		case LPAREN:
 			if (PARLEV > 0)
 				chrsave(t);
-			while (isspace(l = gpbc()))
-				;		/* skip blank, tab, nl.. */
-			putback(l);
+			while (isspace(l = gpbc())) /* skip blank, tab, nl.. */
+				if (PARLEV > 0)
+					chrsave(l);
+			pushback(l);
 			record(paren, PARLEV++);
 			break;
 
@@ -463,11 +447,11 @@
 			else {			/* end of argument list */
 				chrsave(EOS);
 
-				if ((uintptr_t)sp == STACKMAX)
+				if (sp == STACKMAX)
 					errx(1, "internal stack overflow");
 
-				eval((const char **) mstack+fp+1, sp-fp,
-				    CALTYP);
+				eval((const char **) mstack+fp+1, sp-fp, 
+				    CALTYP, TRACESTATUS);
 
 				ep = PREVEP;	/* flush strspace */
 				sp = PREVSP;	/* previous sp..  */
@@ -480,7 +464,7 @@
 				chrsave(EOS);		/* new argument   */
 				while (isspace(l = gpbc()))
 					;
-				putback(l);
+				pushback(l);
 				pushs(ep);
 			} else
 				chrsave(t);
@@ -488,14 +472,14 @@
 
 		default:
 			if (LOOK_AHEAD(t, scommt)) {
-				char *pc;
-				for (pc = scommt; *pc; pc++)
-					chrsave(*pc);
+				char *p;
+				for (p = scommt; *p; p++)
+					chrsave(*p);
 				for(;;) {
 					t = gpbc();
 					if (LOOK_AHEAD(t, ecommt)) {
-						for (pc = ecommt; *pc; pc++)
-							chrsave(*pc);
+						for (p = ecommt; *p; p++)
+							chrsave(*p);
 						break;
 					}
 					if (t == EOF)
@@ -509,39 +493,64 @@
 	}
 }
 
-/*
- * output string directly, without pushing it for reparses.
+/* 
+ * output string directly, without pushing it for reparses. 
  */
 void
 outputstr(const char *s)
 {
 	if (sp < 0)
-		while (*s)
-			putc(*s++, active);
+		reallyoutputstr(s);
 	else
 		while (*s)
 			CHRSAVE(*s++);
 }
 
+void
+reallyoutputstr(const char *s)
+{
+	if (synch_lines) {
+		while (*s) {
+			fputc(*s, active);
+			if (*s++ == '\n') {
+				infile[ilevel].synch_lineno++;
+				if (infile[ilevel].synch_lineno != 
+				    infile[ilevel].lineno)
+					do_emit_synchline();
+			}
+		}
+	} else
+		fputs(s, active);
+}
+
+void
+reallyputchar(int c)
+{
+	putc(c, active);
+	if (synch_lines && c == '\n') {
+		infile[ilevel].synch_lineno++;
+		if (infile[ilevel].synch_lineno != infile[ilevel].lineno)
+			do_emit_synchline();
+	}
+}
+
 /*
  * build an input token..
- * consider only those starting with _ or A-Za-z. This is a
- * combo with lookup to speed things up.
+ * consider only those starting with _ or A-Za-z. 
  */
 static ndptr
-inspect(int c, char *tp)
+inspect(int c, char *tp) 
 {
 	char *name = tp;
 	char *etp = tp+MAXTOK;
 	ndptr p;
-	unsigned int h;
+	
+	*tp++ = c;
 
-	h = *tp++ = c;
-
 	while ((isalnum(c = gpbc()) || c == '_') && tp < etp)
-		h = (h << 5) + h + (*tp++ = c);
+		*tp++ = c;
 	if (c != EOF)
-		PUTBACK(c);
+		PUSHBACK(c);
 	*tp = EOS;
 	/* token is too long, it won't match anything, but it can still
 	 * be output. */
@@ -549,71 +558,43 @@
 		outputstr(name);
 		while (isalnum(c = gpbc()) || c == '_') {
 			if (sp < 0)
-				putc(c, active);
+				reallyputchar(c);
 			else
 				CHRSAVE(c);
 		}
 		*name = EOS;
-		return nil;
+		return NULL;
 	}
 
-	for (p = hashtab[h % HASHSIZE]; p != nil; p = p->nxtptr)
-		if (h == p->hv && STREQ(name, p->name))
-			break;
+	p = ohash_find(&macros, ohash_qlookupi(&macros, name, (const char **)&tp));
+	if (p == NULL)
+		return NULL;
+	if (macro_getdef(p) == NULL)
+		return NULL;
 	return p;
 }
 
 /*
- * initkwds - initialise m4 keywords as fast as possible.
+ * initkwds - initialise m4 keywords as fast as possible. 
  * This very similar to install, but without certain overheads,
- * such as calling lookup. Malloc is not used for storing the
+ * such as calling lookup. Malloc is not used for storing the 
  * keyword strings, since we simply use the static pointers
  * within keywrds block.
  */
 static void
 initkwds(void)
 {
-	size_t i;
-	unsigned int h;
-	ndptr p;
+	unsigned int type;
+	int i;
 
 	for (i = 0; i < MAXKEYS; i++) {
-		h = hash(keywrds[i].knam);
-		p = (ndptr) xalloc(sizeof(struct ndblock));
-		p->nxtptr = hashtab[h % HASHSIZE];
-		hashtab[h % HASHSIZE] = p;
-		p->name = xstrdup(keywrds[i].knam);
-		p->defn = null;
-		p->hv = h;
-		p->type = keywrds[i].ktyp & TYPEMASK;
+		type = keywrds[i].ktyp & TYPEMASK;
 		if ((keywrds[i].ktyp & NOARGS) == 0)
-			p->type |= NEEDARGS;
+			type |= NEEDARGS;
+		setup_builtin(keywrds[i].knam, type);
 	}
 }
 
-/* Look up a builtin type, even if overridden by the user */
-int
-builtin_type(const char *key)
-{
-	int i;
-
-	for (i = 0; i != MAXKEYS; i++)
-		if (STREQ(keywrds[i].knam, key))
-			return keywrds[i].ktyp;
-	return -1;
-}
-
-const char *
-builtin_realname(int n)
-{
-	int i;
-
-	for (i = 0; i != MAXKEYS; i++)
-		if (((keywrds[i].ktyp ^ n) & TYPEMASK) == 0)
-			return keywrds[i].knam;
-	return NULL;
-}
-
 static void
 record(struct position *t, int lev)
 {
@@ -633,29 +614,20 @@
 			fprintf(stderr, "   ...\n");
 			break;
 		}
-		fprintf(stderr, "   %s at line %lu\n",
+		fprintf(stderr, "   %s at line %lu\n", 
 			t[i].name, t[i].line);
 	}
 }
 
 
-static void
+static void 
 enlarge_stack(void)
 {
-	STACKMAX *= 2;
-	mstack = realloc(mstack, sizeof(stae) * STACKMAX);
-	sstack = realloc(sstack, STACKMAX);
-	if (mstack == NULL || sstack == NULL)
-		errx(1, "Evaluation stack overflow (%lu)",
-		    (unsigned long)STACKMAX);
+	STACKMAX += STACKMAX/2;
+	mstack = xrealloc(mstack, sizeof(stae) * STACKMAX, 
+	    "Evaluation stack overflow (%lu)", 
+	    (unsigned long)STACKMAX);
+	sstack = xrealloc(sstack, STACKMAX,
+	    "Evaluation stack overflow (%lu)", 
+	    (unsigned long)STACKMAX);
 }
-
-/* Emit preprocessor #line directive if -s option used. */
-void
-emitline(void)
-{
-
-	if (synccpp)
-		fprintf(active, "#line %d \"%s\"\n", inlineno[ilevel],
-			inname[ilevel]);
-}
Index: ohash_delete.c
===================================================================
--- ohash_delete.c	(revision 0)
+++ ohash_delete.c	(revision 0)
@@ -0,0 +1,31 @@
+/* $OpenBSD: ohash_delete.c,v 1.2 2004/06/22 20:00:16 espie Exp $ */
+/* ex:ts=8 sw=4: 
+ */
+
+/* Copyright (c) 1999, 2004 Marc Espie <espie@openbsd.org>
+ *
+ * Permission to use, copy, modify, and distribute this software for any
+ * purpose with or without fee is hereby granted, provided that the above
+ * copyright notice and this permission notice appear in all copies.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
+ * WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
+ * MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
+ * ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
+ * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
+ * ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
+ * OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
+ */
+
+#include "ohash_int.h"
+/* hash_delete only frees the hash structure. Use hash_first/hash_next
+ * to free entries as well.  */
+void 
+ohash_delete(struct ohash *h)
+{
+	(h->info.hfree)(h->t, sizeof(struct _ohash_record) * h->size,
+		h->info.data);
+#ifndef NDEBUG
+	h->t = NULL;
+#endif
+}
Index: pathnames.h
===================================================================
--- pathnames.h	(revision 198625)
+++ pathnames.h	(working copy)
@@ -1,4 +1,4 @@
-/*	$OpenBSD: pathnames.h,v 1.4 1997/04/04 18:41:29 deraadt Exp $	*/
+/*	$OpenBSD: pathnames.h,v 1.5 2003/06/03 02:56:10 millert Exp $	*/
 /*	$NetBSD: pathnames.h,v 1.6 1995/09/29 00:27:55 cgd Exp $	*/
 
 /*
@@ -16,11 +16,7 @@
  * 2. Redistributions in binary form must reproduce the above copyright
  *    notice, this list of conditions and the following disclaimer in the
  *    documentation and/or other materials provided with the distribution.
- * 3. All advertising materials mentioning features or use of this software
- *    must display the following acknowledgement:
- *	This product includes software developed by the University of
- *	California, Berkeley and its contributors.
- * 4. Neither the name of the University nor the names of its contributors
+ * 3. Neither the name of the University nor the names of its contributors
  *    may be used to endorse or promote products derived from this software
  *    without specific prior written permission.
  *
@@ -37,7 +33,6 @@
  * SUCH DAMAGE.
  *
  *	@(#)pathnames.h	8.1 (Berkeley) 6/6/93
- * $FreeBSD$
  */
 
 /*
@@ -50,8 +45,7 @@
 #define	UNIQUE		3			/* unique char location */
 #endif
 
-#if defined(unix) || defined(__FreeBSD__) || defined(__NetBSD__) || \
-	defined(__OpenBSD__)
+#if defined(unix) || defined(__NetBSD__) || defined(__OpenBSD__)
 #define _PATH_DIVNAME	"/tmp/m4.0XXXXXXXXXX"	/* unix diversion files */
 #define UNIQUE		8			/* unique char location */
 #endif
Index: ohash_init.c
===================================================================
--- ohash_init.c	(revision 0)
+++ ohash_init.c	(revision 0)
@@ -0,0 +1,41 @@
+/* $OpenBSD: ohash_init.c,v 1.2 2004/06/22 20:00:16 espie Exp $ */
+/* ex:ts=8 sw=4: 
+ */
+
+/* Copyright (c) 1999, 2004 Marc Espie <espie@openbsd.org>
+ *
+ * Permission to use, copy, modify, and distribute this software for any
+ * purpose with or without fee is hereby granted, provided that the above
+ * copyright notice and this permission notice appear in all copies.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
+ * WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
+ * MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
+ * ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
+ * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
+ * ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
+ * OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
+ */
+
+#include "ohash_int.h"
+
+void 
+ohash_init(struct ohash *h, unsigned int size, struct ohash_info *info)
+{
+	h->size = 1UL << size;
+	if (h->size < MINSIZE)
+		h->size = MINSIZE;
+#ifdef STATS_HASH
+	STAT_HASH_CREATION++;
+	STAT_HASH_SIZE += h->size;
+#endif
+	/* Copy info so that caller may free it.  */
+	h->info.key_offset = info->key_offset;
+	h->info.halloc = info->halloc;
+	h->info.hfree = info->hfree;
+	h->info.alloc = info->alloc;
+	h->info.data = info->data;
+	h->t = (h->info.halloc)(sizeof(struct _ohash_record) * h->size,
+	    h->info.data);
+	h->total = h->deleted = 0;
+}
Index: ohash_enum.c
===================================================================
--- ohash_enum.c	(revision 0)
+++ ohash_enum.c	(revision 0)
@@ -0,0 +1,36 @@
+/* $OpenBSD: ohash_enum.c,v 1.3 2004/06/22 20:00:16 espie Exp $ */
+/* ex:ts=8 sw=4: 
+ */
+
+/* Copyright (c) 1999, 2004 Marc Espie <espie@openbsd.org>
+ *
+ * Permission to use, copy, modify, and distribute this software for any
+ * purpose with or without fee is hereby granted, provided that the above
+ * copyright notice and this permission notice appear in all copies.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
+ * WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
+ * MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
+ * ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
+ * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
+ * ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
+ * OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
+ */
+
+#include "ohash_int.h"
+
+void *
+ohash_first(struct ohash *h, unsigned int *pos)
+{
+	*pos = 0;
+	return ohash_next(h, pos);
+}
+	
+void *
+ohash_next(struct ohash *h, unsigned int *pos)
+{
+	for (; *pos < h->size; (*pos)++) 
+		if (h->t[*pos].p != DELETED && h->t[*pos].p != NULL) 
+			return (void *)h->t[(*pos)++].p;
+	return NULL;
+}
